-----------------------------------------------------------------------------------------------
-- Client Lua Script for FlyHUD
-- Copyright (c) Sonicvi. All rights reserved
-----------------------------------------------------------------------------------------------

 
require "Window"


-----------------------------------------------------------------------------------------------
-- ToDo
-----------------------------------------------------------------------------------------------
 --Bouton non clicable 
 --Archtype Mmorisation
 --align to
 --usable spell
-----------------------------------------------------------------------------------------------
-- Fonction interessante
-----------------------------------------------------------------------------------------------
 --AbilityBook.GetAbilitiesList()
 --ActionSetLib.GetCurrentActionSet()
 --GetSpell(SpellID)

-----------------------------------------------------------------------------------------------
-- FlyHUD Module Definition
-----------------------------------------------------------------------------------------------
local FlyHUD = {}
local DataSave=0 
local Opacity=0.5
local Taille=85
local Position={}
local visible={0,0,0,0,0,0,0,0,0}
local SetCD=0
local EtatCD={1,1,1,1,1,1,1,1,1}
local wndOpen=0
local SetCombat=0
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function FlyHUD:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function FlyHUD:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = "FlyHUD"
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- FlyHUD OnLoad
-----------------------------------------------------------------------------------------------
function FlyHUD:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("FlyHUD.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- FlyHUD OnDocLoaded
-----------------------------------------------------------------------------------------------
function FlyHUD:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "FlyHUDForm", nil, self)
		self.BSpell ={
		 Apollo.LoadForm(self.xmlDoc, "BSpell1", nil, self),
		 Apollo.LoadForm(self.xmlDoc, "BSpell2", nil, self),
		 Apollo.LoadForm(self.xmlDoc, "BSpell3", nil, self),
		 Apollo.LoadForm(self.xmlDoc, "BSpell4", nil, self),
		 Apollo.LoadForm(self.xmlDoc, "BSpell5", nil, self),
		 Apollo.LoadForm(self.xmlDoc, "BSpell6", nil, self),
		 Apollo.LoadForm(self.xmlDoc, "BSpell7", nil, self),
		 Apollo.LoadForm(self.xmlDoc, "BSpell8", nil, self),
		 Apollo.LoadForm(self.xmlDoc, "BInnate", nil, self)}
		self.FormSpell ={ 
		 Apollo.LoadForm(self.xmlDoc, "FormSpell1", nil, self),
		 Apollo.LoadForm(self.xmlDoc, "FormSpell2", nil, self),
		 Apollo.LoadForm(self.xmlDoc, "FormSpell3", nil, self),
		 Apollo.LoadForm(self.xmlDoc, "FormSpell4", nil, self),
		 Apollo.LoadForm(self.xmlDoc, "FormSpell5", nil, self),
		 Apollo.LoadForm(self.xmlDoc, "FormSpell6", nil, self),
		 Apollo.LoadForm(self.xmlDoc, "FormSpell7", nil, self),
		 Apollo.LoadForm(self.xmlDoc, "FormSpell8", nil, self),
		 Apollo.LoadForm(self.xmlDoc, "FormInnate", nil, self)}
		 self.test = Apollo.LoadForm(self.xmlDoc, "Form", nil, self)

		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
	    self.wndMain:Show(false, true)
	
		for i=1,9 do
			self.FormSpell[i]:Show(false,true)
			self.BSpell[i]:Show(false,true)
		end
			
		-- if the xmlDoc is no longer needed, you should set it to nil
		-- self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)
		Apollo.RegisterSlashCommand("FlyHUD", "OnFlyHUDOn", self)
		Apollo.RegisterSlashCommand("flyhud", "OnFlyHUDOn", self)
		Apollo.RegisterEventHandler("VarChange_FrameCount", "OnFrame", self)
		
		FlyHUD:Initialize(self)

		-- Do additional Addon initialization here
	end
end
function FlyHUD:OnSave(eType)
    if eType~=GameLib.CodeEnumAddonSaveLevel.Character then
        return nil
    end

    local tSave = {}
	tSave.test=0
	for j=1,9 do
		Position[j*4-3],Position[j*4-2],Position[j*4-1],Position[j*4] = self.FormSpell[j]:GetAnchorOffsets()
	end
    tSave.visible = visible
	tSave.Taille = Taille
	tSave.Opacity = Opacity
    tSave.Position=Position
	tSave.SetCD=SetCD
	tSave.SetCombat=SetCombat
    return tSave
end

function FlyHUD:OnRestore(eType,tSavedData)
	if eType ~= GameLib.CodeEnumAddonSaveLevel.Character then
		return 
	end


	if tSavedData.visible then  
		visible=tSavedData.visible
		DataSave=DataSave+1
	end
	if tSavedData.Taille then
		Taille=tSavedData.Taille
		DataSave=DataSave+1

	end
	if tSavedData.Opacity then
		Opacity=tSavedData.Opacity
		DataSave=DataSave+1
	end
	if tSavedData.Position then
		Position=tSavedData.Position
		DataSave=DataSave+1
	end
	
	if tSavedData.SetCD then
		SetCD=tSavedData.SetCD
	end
	if tSavedData.SetCombat then
		SetCombat=tSavedData.SetCombat
	end
end

-----------------------------------------------------------------------------------------------
-- FlyHUD Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

-- on SlashCommand "/CD"
function FlyHUD:OnFlyHUDOn()
	wndOpen=1
	self.wndMain:Invoke() -- show the window
	for i=1,9 do
		self.BSpell[i]:Show(false)
		if visible[i]==1 then
			self.FormSpell[i]:Show(true)
		end
	end

end

function FlyHUD:Initialize(self)
	
	local spell={self.wndMain:FindChild("Aff"):FindChild("Spell1"),
				 self.wndMain:FindChild("Aff"):FindChild("Spell2"),
				 self.wndMain:FindChild("Aff"):FindChild("Spell3"),
				 self.wndMain:FindChild("Aff"):FindChild("Spell4"),
				 self.wndMain:FindChild("Aff"):FindChild("Spell5"),
				 self.wndMain:FindChild("Aff"):FindChild("Spell6"),
				 self.wndMain:FindChild("Aff"):FindChild("Spell7"),
				 self.wndMain:FindChild("Aff"):FindChild("Spell8"),
				 self.wndMain:FindChild("Aff"):FindChild("Innate")	
					}

	--self.wndMain:FindChild("EditBox"):SetText(tostring(DataSave))
	local general= self.wndMain:FindChild("general")
	
	if Taille then

		general:FindChild("EditTaille"):SetText(Taille )
		general:FindChild("Taille"):SetValue(Taille)

	end
	if Opacity then
		general:FindChild("EditOpacity"):SetText(Opacity)
		general:FindChild("Opacity"):SetValue(Opacity)
	end
	if Position and DataSave==4 then
		for i=1,9 do
			self.FormSpell[i]:SetAnchorOffsets(Position[i*4-3],Position[i*4-2],Position[i*4-1],Position[i*4])
		end
	end
	for i=1,9 do
		self.FormSpell[i]:SetOpacity(Opacity)
		self.BSpell[i]:SetOpacity(Opacity)
		R,T,L,B=self.FormSpell[i]:GetAnchorOffsets()
		self.BSpell[i]:SetAnchorOffsets(R+5,T+5,R+Taille-5,T+Taille-5)
		self.FormSpell[i]:SetAnchorOffsets(R,T,R+Taille,T+Taille)
		if visible[i]==1 then
			self.BSpell[i]:Show(true)
			spell[i]:SetCheck(1)
		end
	end
	if SetCD==1 then
		self.wndMain:FindChild("general"):FindChild("CoolDown"):SetCheck(1)
	end
	if SetCombat==1 then
		self.wndMain:FindChild("general"):FindChild("Combat"):SetCheck(1)
	end
end



-----------------------------------------------------------------------------------------------
-- FlyHUDForm Functions
-----------------------------------------------------------------------------------------------

function FlyHUD:OnFrame()
	if SetCD==1 and wndOpen==0 then	
		local LASlist=ActionSetLib.GetCurrentActionSet()
		local Abilities=AbilityBook.GetAbilitiesList()
		local spell=0
		for i=1,9 do
			if i<9 then
				for id = 1, #Abilities do
					if Abilities[id].nId==LASlist[i] then
		
						spell = Abilities[id].tTiers[Abilities[id].nCurrentTier].splObject
						if spell:GetCooldownRemaining() > 0 then
							EtatCD[i]=0
						else
							EtatCD[i]=1
						end					
						
					end
				end
			else
				if GameLib.GetCurrentClassInnateAbilitySpell():GetCooldownRemaining() > 0 then
					EtatCD[9]=0
				else
					EtatCD[9]=1
				end
			end

		end
	
	end
	if GameLib.GetPlayerUnit():IsInCombat()==true and wndOpen==0 and SetCombat==1 then
		for i=1,9 do
			if visible[i]==1 and EtatCD[i]==1  then
				self.BSpell[i]:Show(true,true)
			else
				self.BSpell[i]:Show(false,true)
			end
		end
	elseif GameLib.GetPlayerUnit():IsInCombat()==false and wndOpen==0 and SetCombat==1 then
		for i=1,9 do
			self.BSpell[i]:Show(false,true)
		end
	elseif wndOpen==0 and SetCombat==0 then 
		for i=1,9 do
			if visible[i]==1 and EtatCD[i]==1  then
				self.BSpell[i]:Show(true,true)
			else
				self.BSpell[i]:Show(false,true)
			end
		end
	end
	--self.test:SetText(tostring(GameLib.GetPlayerUnit():IsInCombat()))
end	
	-- when the Cancel button is clicked
function FlyHUD:OnCancel()
	self.wndMain:Close() -- hide the window
	wndOpen=0
	EtatCD={1,1,1,1,1,1,1,1,1}
	for i=1,9 do
		R,T,L,B=self.FormSpell[i]:GetAnchorOffsets()
		self.BSpell[i]:SetAnchorOffsets(R+5,T+5,L-5,B-5)
		if visible[i]==1 then
			self.BSpell[i]:Show(true)
		end
	end
	for i=1,9 do
		self.FormSpell[i]:Show(false)
	end

end


function FlyHUD:ChgTaille( wndHandler, wndControl, fNewValue, fOldValue )
	for i=1,9 do
		R,T,L,B=self.FormSpell[i]:GetAnchorOffsets()
		self.FormSpell[i]:SetAnchorOffsets(R,T,R+fNewValue,T+fNewValue)
	end
	Taille=math.floor(fNewValue)
	local general= self.wndMain:FindChild("general")
	general:FindChild("EditTaille"):SetText(Taille)
end

function FlyHUD:ChgOpa( wndHandler, wndControl, fNewValue, fOldValue )
	Opacity=math.floor(fNewValue)/10
	for i=1,9 do
		self.FormSpell[i]:SetOpacity(Opacity)
		self.BSpell[i]:SetOpacity(Opacity)

	end
	local general= self.wndMain:FindChild("general")
	general:FindChild("EditOpacity"):SetText(math.floor(fNewValue)/10)
end

function FlyHUD:Lock( wndHandler, wndControl, eMouseButton )
	lock=wndControl:IsChecked()
		for i=1,9 do
		self.FormSpell[i]:SetStyle("Moveable", not lock)

	end
	
end

function FlyHUD:AffSpell1( wndHandler, wndControl, eMouseButton )
	check=wndControl:IsChecked()

	
	if check then
		self.FormSpell[1]:Show(true)
		visible[1]=1
	else
		self.FormSpell[1]:Show(false)
		visible[1]=0
	end
		
end
function FlyHUD:AffSpell2( wndHandler, wndControl, eMouseButton )
	check=wndControl:IsChecked()
	if check then
		self.FormSpell[2]:Show(true)
		visible[2]=1
	else
		self.FormSpell[2]:Show(false)
		visible[2]=0
	end
		
end
function FlyHUD:AffSpell3( wndHandler, wndControl, eMouseButton )
	check=wndControl:IsChecked()
	if check then
		self.FormSpell[3]:Show(true)
		visible[3]=1
	else
		self.FormSpell[3]:Show(false)
		visible[3]=0
	end
		
end
function FlyHUD:AffSpell4( wndHandler, wndControl, eMouseButton )
	check=wndControl:IsChecked()
	if check then
		self.FormSpell[4]:Show(true)
		visible[4]=1
	else
		self.FormSpell[4]:Show(false)
		visible[4]=0
	end
		
end
function FlyHUD:AffSpell5( wndHandler, wndControl, eMouseButton )
	check=wndControl:IsChecked()
	if check then
		self.FormSpell[5]:Show(true)
		visible[5]=1
	else
		self.FormSpell[5]:Show(false)
		visible[5]=0
	end
		
end
function FlyHUD:AffSpell6( wndHandler, wndControl, eMouseButton )
	check=wndControl:IsChecked()
	if check then
		self.FormSpell[6]:Show(true)
		visible[6]=1
	else
		self.FormSpell[6]:Show(false)
		visible[6]=0
	end
		
end
function FlyHUD:AffSpell7( wndHandler, wndControl, eMouseButton )
	check=wndControl:IsChecked()
	if check then
		self.FormSpell[7]:Show(true)
		visible[7]=1
	else
		self.FormSpell[7]:Show(false)
		visible[7]=0
	end
		
end
function FlyHUD:AffSpell8( wndHandler, wndControl, eMouseButton )
	check=wndControl:IsChecked()
	if check then
		self.FormSpell[8]:Show(true)
		visible[8]=1
	else
		self.FormSpell[8]:Show(false)
		visible[8]=0
	end
		
end
function FlyHUD:AffSpell9( wndHandler, wndControl, eMouseButton )
	check=wndControl:IsChecked()
	if check then
		self.FormSpell[9]:Show(true)
		visible[9]=1
	else
		self.FormSpell[9]:Show(false)
		visible[9]=0
	end
		
end

function FlyHUD:SetCD( wndHandler, wndControl, eMouseButton )
	if wndControl:IsChecked() then
		SetCD=1
	else
		SetCD=0
	end
end

function FlyHUD:SetCombat( wndHandler, wndControl, eMouseButton )
	if wndControl:IsChecked() then
		SetCombat=1
	else
		SetCombat=0
	end
end

-----------------------------------------------------------------------------------------------
-- FlyHUD Instance
-----------------------------------------------------------------------------------------------
local FlyHUDInst = FlyHUD:new()
FlyHUDInst:Init()
